package labss.lang.il.builders;

import labss.lang.il.factories.ILAbstractFactory;
import labss.lang.il.factories.ILPrototypeManager;
import labss.lang.il.model.ILEntity;
import labss.lang.il.model.ILType;

/**
 * @author Riccardo Solmi
 */
public class Event2EntityBuilderAdapter implements EventBuilder {
	protected EntityBuilder adaptee = new DescendantOrSelfEntityBuilder();
	protected final ILPrototypeManager pm = ILPrototypeManager.instance();
	protected final ILAbstractFactory ef = ILAbstractFactory.instance;

	public Event2EntityBuilderAdapter(EntityBuilder adaptee) {
		this.adaptee = adaptee;
	}

	public ILEntity getResult() {
		return adaptee.getResult();
	}

	public void build(ILType type, boolean value) {
		adaptee.build(ef.createBoolean(value));
	}
	public void build(ILType type, int value) {
		adaptee.build(ef.createInt(value));
	}
	public void build(ILType type, String value) {
		adaptee.build(ef.createVariable(value));
	}
	public void build(ILType type) {
		adaptee.build(pm.create(type));
	}

	public void startBuild(ILType type) {
		adaptee.startBuild(pm.create(type));
	}
	public void endBuild() {
		adaptee.endBuild();
	}
}
