package labss.lang.il.factories;

import labss.lang.il.model.Statement;
import labss.lang.il.model.impl.Empty;
import labss.lang.il.model.impl.NullExpression;

/**
 * @author Riccardo Solmi
 */
public class ILPrototypeManager extends PrototypeManager {
	private static ILPrototypeManager instance;
	public static ILPrototypeManager instance() {
		if (instance == null)
			instance = new ILPrototypeManager();
		return instance;
	}

	protected ILPrototypeManager() {
		final ILAbstractFactory lf = ILAbstractFactory.instance; 

		put("Empty", Empty.instance);
		put("NullExpression", NullExpression.instance);
		
		put("While", lf.createWhile(NullExpression.instance, Empty.instance));
		put("IfThen", lf.createIf(NullExpression.instance, Empty.instance));
		put("IfThenElse", lf.createIf(NullExpression.instance, Empty.instance, Empty.instance));
		put("Assignment", lf.createAssignment("var", NullExpression.instance));
		put("Block", lf.createBlock(new Statement[0]));
		put("Int", lf.createInt(0));
		put("Bool", lf.createBoolean(false));
		put("Variable", lf.createVariable("var"));
		put("Addition", lf.createAddition(NullExpression.instance, NullExpression.instance));
		put("Subtraction", lf.createSubtraction(NullExpression.instance, NullExpression.instance));
		put("Multiplication", lf.createMultiplication(NullExpression.instance, NullExpression.instance));
		put("Division", lf.createDivision(NullExpression.instance, NullExpression.instance));
		put("And", lf.createAnd(NullExpression.instance, NullExpression.instance));
		put("Or", lf.createOr(NullExpression.instance, NullExpression.instance));
		put("Not", lf.createNot(NullExpression.instance));
		put("Equals", lf.createEquals(NullExpression.instance, NullExpression.instance));
		put("Or", lf.createOr(NullExpression.instance, NullExpression.instance));
		put("LessThan", lf.createLessThan(NullExpression.instance, NullExpression.instance));
		put("GreaterThan", lf.createGreaterThan(NullExpression.instance, NullExpression.instance));
	}
}
