package labss.lang.il.factories;

import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import labss.lang.il.model.ILEntity;
import labss.lang.il.model.ILType;

/**
 * @author Riccardo Solmi
 */
public class PrototypeManager {
	private Map<String, ILEntity> registry = new HashMap<String, ILEntity>();

	public final ILEntity create(ILType type) {
		return create(type.name);
	}
	public ILEntity create(String name) {
		ILEntity prototype = registry.get(name);
		if (prototype == null)
			throw new IllegalArgumentException("prototype sconosciuto: "+name);

		return (ILEntity) prototype.clone();
	}
	public void put(String name, ILEntity prototype) {
		registry.put(name, prototype);
	}
	public void remove(String name) {
		registry.remove(name);
	}
	public Set<String> names() {
		return registry.keySet();
	}
}
