package labss.lang.il.factories;

import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import labss.lang.il.model.ILEntity;

/**
 * @author Riccardo Solmi
 */
public class TemplateManager {
	private Map<String, TemplateFactory> registry = new HashMap<String, TemplateFactory>();

	public ILEntity create(String name) {
		return create(name, (Object[]) null);
	}
	public ILEntity create(String name, Object... args) {
		TemplateFactory tf = registry.get(name);
		if (tf == null)
			throw new IllegalArgumentException("template sconosciuto: "+name);

		return tf.create(args);
	}
	public void put(String name, TemplateFactory tf) {
		registry.put(name, tf);
	}
	public void put(String name, ILEntity prototype) {
		registry.put(name, new PrototypeFactory(prototype));
	}
	public void remove(String name) {
		registry.remove(name);
	}
	public Set<String> names() {
		return registry.keySet();
	}
}
