package labss.lang.il.model;

import java.io.*;
import java.util.List;

import labss.lang.il.visitors.ILVisitor;

/**
 * E' l'intefaccia comune a tutte le entit del linguaggio. <p/>Le classi del
 * linguaggio devono implementare una delle sotto interfacce definite.
 * 
 * @author Riccardo Solmi
 */

public interface ILEntity5 extends Cloneable, List<ILEntity5> {
	public Object clone();

	public ILType getType();
	public int getOrdinal();

//	public int size();
//	public LanguageEntity5 get(int index);
//	public LanguageEntity5 set(int index, LanguageEntity5 child);
//	public boolean add(LanguageEntity5 child);
//	public void add(int index, LanguageEntity5 child);
//	public LanguageEntity5 remove(int index);

	public ILEntity5 get(ILProperty property);
	public void set(ILProperty property, ILEntity5 value);

	public void accept(ILVisitor visitor);

	public void prettyPrint(PrintStream out);
}