package labss.lang.il.model.impl;

import labss.lang.il.model.ILEntity;
import labss.lang.il.model.ILProperty;

/**
 * @author Riccardo Solmi
 */
public abstract class AbstractILEntity implements ILEntity {
	public Object clone() {
		try {
			return super.clone();
		} catch (CloneNotSupportedException e) {
			throw new InternalError();
		}
	}

	public final int getOrdinal() {
		return getType().ordinal;
	}

	public int size() {
		return 0;
	}
	public ILEntity get(int index) {
		throw new IllegalArgumentException();
	}
	public void set(int index, ILEntity value) {
		throw new IllegalArgumentException();
	}

	public void add(ILEntity child) {
		throw new IllegalStateException("Illegal method call for this object");
	}

	public void add(int index, ILEntity child) {
		throw new IllegalStateException("Illegal method call for this object");
	}

	public ILEntity remove(int index) {
		throw new IllegalStateException("Illegal method call for this object");
	}

	public final ILEntity get(ILProperty property) {
		return get(indexOf(property));
	}
	public final void set(ILProperty property, ILEntity value) {
		set(indexOf(property), value);
	}
	protected int indexOf(ILProperty property) {
		throw new IllegalArgumentException();
	}
}