package labss.lang.il.model.impl;

import labss.lang.il.model.Expression;
import labss.lang.il.model.ILEntity;
import labss.lang.il.model.ILPropertiesEnum;
import labss.lang.il.model.ILProperty;

public abstract class BinaryExpression extends AbstractILEntity implements Expression {
	private Expression exp1;
	private Expression exp2;

	protected BinaryExpression(Expression exp1, Expression exp2) {
		this.exp1 = exp1;
		this.exp2 = exp2;
	}

	public Object clone() {
		BinaryExpression e = (BinaryExpression) super.clone();
		e.exp1 = (Expression) exp1.clone();
		e.exp2 = (Expression) exp2.clone();
		return e;
	}

	public Expression getExp1() {
		return exp1;
	}
	public void setExp1(Expression exp1) {
		this.exp1 = exp1;
	}
	public Expression getExp2() {
		return exp2;
	}
	public void setExp2(Expression exp2) {
		this.exp2 = exp2;
	}

	public int size() {
		return 2;
	}
	public ILEntity get(int index) {
		switch (index) {
		case 0:
			return getExp1();
		case 1:
			return getExp2();
		default:
			throw new IllegalArgumentException();
		}
	}
	public void set(int index, ILEntity value) {
		switch (index) {
		case 0:
			setExp1((Expression) value);
			break;
		case 1:
			setExp2((Expression) value);
			break;
		default:
			throw new IllegalArgumentException();
		}
	}
	protected int indexOf(ILProperty property) {
		switch (property.ordinal) {
		case ILPropertiesEnum.pExp1_ord:
			return 0;
		case ILPropertiesEnum.pExp2_ord:
			return 1;
		default:
			throw new IllegalArgumentException();
		}
	}
}