package labss.lang.il.model.impl;

import java.util.ArrayList;

import labss.lang.il.factories.ILAbstractFactory;
import labss.lang.il.model.ILEntity;
import labss.lang.il.model.ILType;
import labss.lang.il.model.ILType5;
import labss.lang.il.model.ILTypesEnum;
import labss.lang.il.model.Statement;
import labss.lang.il.visitors.ILVisitor;

/**
 * @author Riccardo Solmi
 */

public class Block extends AbstractILEntity implements Statement {
	private ArrayList<ILEntity> stm;

	public Block(Statement[] stm) {
		this.stm = new ArrayList<ILEntity>(stm.length);
		for (int i = 0; i < stm.length; i++)
			this.add(stm[i]);
	}

	@SuppressWarnings("unchecked")
	public Object clone() {
		Block s = (Block) super.clone();
		s.stm = (ArrayList<ILEntity>) stm.clone();
		for (int i = 0; i < s.size(); i++)
			s.set(i, (Statement) s.get(i).clone());
		return s;
	}

	public ILType5 getType5() {
		return ILType5.Block;
	}
	public ILType getType() {
		return ILTypesEnum.tBlock;
	}

	public void accept(ILVisitor visitor) {
		visitor.visit(this);
	}

	public ILEntity get(int index) {
		return stm.get(index);
	}

	public void set(int index, ILEntity child) {
		while (stm.size() <= index)
			stm.add(ILAbstractFactory.instance.createEmpty());
		
		stm.set(index, child);
	}

	public void add(ILEntity child) {
		stm.add(child);
	}

	public void add(int index, ILEntity child) {
		stm.add(index, child);
	}

	public ILEntity remove(int index) {
		return stm.remove(index);
	}

	public int size() {
		return stm.size();
	}
}