package labss.lang.il.model.impl;

import labss.lang.il.model.Expression;
import labss.lang.il.model.ILEntity;
import labss.lang.il.model.ILPropertiesEnum;
import labss.lang.il.model.ILProperty;
import labss.lang.il.model.ILType;
import labss.lang.il.model.ILType5;
import labss.lang.il.model.ILTypesEnum;
import labss.lang.il.model.Statement;
import labss.lang.il.visitors.ILVisitor;

/**
 * @author Riccardo Solmi
 */

public class IfElse extends ConditionalStatement {
	private Statement falseBody;

	protected IfElse(Expression condition, Statement trueBody, Statement falseBody) {
		super(condition, trueBody);
		this.falseBody = falseBody;
	}

	public Object clone() {
		IfElse s = (IfElse) super.clone();
		s.falseBody = (Statement) falseBody.clone();
		return s;
	}

	public ILType5 getType5() {
		return ILType5.IfElse;
	}
	public ILType getType() {
		return ILTypesEnum.tIfElse;
	}

	public void accept(ILVisitor visitor) {
		visitor.visit(this);
	}

	public Statement getFalseBody() {
		return falseBody;
	}

	public void setFalseBody(Statement falseBody) {
		this.falseBody = falseBody;
	}

	public int size() {
		return 3;
	}
	public ILEntity get(int index) {
		switch (index) {
		case 2:
			return getFalseBody();
		default:
			return super.get(index);
		}
	}
	public void set(int index, ILEntity value) {
		switch (index) {
		case 2:
			setFalseBody((Statement) value);
			break;
		default:
			super.set(index, value);
		}
	}
	protected int indexOf(ILProperty property) {
		switch (property.ordinal) {
		case ILPropertiesEnum.pFalseBody_ord:
			return 2;
		default:
			return super.indexOf(property);
		}
	}
}