package labss.lang.il.model.impl;

import labss.lang.il.model.Expression;
import labss.lang.il.model.ILEntity;
import labss.lang.il.model.ILPropertiesEnum;
import labss.lang.il.model.ILProperty;
import labss.lang.il.model.ILType;
import labss.lang.il.model.ILType5;
import labss.lang.il.model.ILTypesEnum;
import labss.lang.il.visitors.ILVisitor;

/**
 * @author Riccardo Solmi
 */

public class Not extends AbstractILEntity implements Expression {
	private Expression exp;

	protected Not(Expression exp) {
		this.exp = exp;
	}

	public Object clone() {
		Not e = (Not) super.clone();
		e.exp = (Expression) exp.clone();
		return e;
	}

	public ILType5 getType5() {
		return ILType5.Not;
	}
	public ILType getType() {
		return ILTypesEnum.tNot;
	}

	public void accept(ILVisitor visitor) {
		visitor.visit(this);
	}

	public Expression getExp() {
		return exp;
	}
	public void setExp(Expression exp) {
		this.exp = exp;
	}

	public int size() {
		return 1;
	}
	public ILEntity get(int index) {
		switch (index) {
		case 0:
			return getExp();
		default:
			throw new IllegalArgumentException();
		}
	}
	public void set(int index, ILEntity value) {
		switch (index) {
		case 0:
			setExp((Expression) value);
			break;
		default:
			throw new IllegalArgumentException();
		}
	}
	protected int indexOf(ILProperty property) {
		switch (property.ordinal) {
		case ILPropertiesEnum.pExp_ord:
			return 0;
		default:
			throw new IllegalArgumentException();
		}
	}
}