package labss.lang.il.visitors;

import java.io.PrintStream;

import labss.lang.il.model.ILEntity;
import labss.lang.il.model.impl.BinaryExpression;
import labss.lang.il.model.impl.Empty;
import labss.lang.il.model.impl.If;
import labss.lang.il.model.impl.While;

/**
 * @author Riccardo Solmi
 */
public class PrettyPrintIfInstanceofBased {
	protected final PrintStream out;
	int indentation = 0;
	
	protected PrettyPrintIfInstanceofBased(PrintStream out) {
		this.out = out;
	}

	public static void prettyPrint(ILEntity entity, PrintStream out) {
		new PrettyPrintIfInstanceofBased(out).switchOn(entity);
	}

	public void switchOn(ILEntity entity) {
		if (entity instanceof Empty) {
			out.println(";");
		} else if (entity instanceof While) {
			caseWhile((While) entity);
		} else if (entity instanceof If) {
			caseIf((If) entity);
		} else if (entity instanceof BinaryExpression) {
			switchOn(((BinaryExpression) entity).getExp1());
			out.print(entity.getType().opStr);
			switchOn(((BinaryExpression) entity).getExp2());
		} //...
	}

	private void caseWhile(While entity) {
		out.print("while (");
		switchOn(entity.getCondition());
		out.println(") {");
		switchOn(entity.getTrueBody());
		out.println("}");
	}

	private void caseIf(If entity) {
		out.print("if (");
		switchOn(entity.getCondition());
		out.println(") {");
		indentation++;
		switchOn(entity.getTrueBody());
		out.println("}");
	}
}
